Proiect: Smart piggy bank
Autor: Barbusi Darius-Alexandru, 344C1

Prezentare generala:
Proiectul meu ofera o solutie inovatoare pentru gestionarea personala a economiilor, combinand caracteristici de securitate cu usurinta in utilizare. Proiectul utilizeaza o placa Arduino Uno pentru a controla diverse componente, inclusiv un senzor de culoare, un LCD, servomotoare, un buzzer si butoane de intrare.

Configurare initiala:
Pentru a incepe proiectul, am adaugat bibliotecile necesare, s-au definit pini pentru fiecare componenta si s-au initializat variabilele. Funtia setup initiaza toate componentele si configureaza rutinele de intrerupere (ISR) pentru cele doua butoane de intrare.

Functionalitatea butoanelor:
Butonul de reset:
Cand butonul de resetare este apasat, o intrerupere declanseaza procesul de reset. Acest proces seteaza suma totala la zero, misca servomotorul din pozitia initiala in pozitia maxima, asteapta 15 secunde, apoi revine la pozitia initiala. Buzzerul emite un sunet care indica faptul ca sistemul a revenit la starea initiala.

Butonul pentru introducerea bancnotelor:
Inainte de a apasa butonul pentru introducerea bancnotelor, trebuie introdusa o bancnota. Senzorul de culoare scaneaza bancnota si determina intensitatea RGB. Media a 10 valori este calculata pentru fiecare componenta de culoare (R, G, B). Servomotorul se deplaseaza apoi intr-o pozitie final pentru a depozita bancnota In zona de stocare, dupa care revine la pozitia initiala. Buzzerul emite un sunet pentru a semnala ca sistemul se afla din nou in pozitia initiala. Valorile determinate pentru fiecare tip de bancnota au fost obtinute experimental pentru toate tipurile de bancnote in cele patru moduri posibile de introducere.

Senzorul de culoare si identificarea bancnotelor:
Citirile senzorului de culoare sunt utilizate pentru a identifica valoarea bancnotei introduse. Valorile sunt determinate prin medierea mai multor citiri pentru a asigura acuratetea. Aceste valori experimentale sunt folosite pentru a recunoaste corect bancnotele.

Display LCD:
Display-ul LCD arata suma totala a bancnotelor introduse. De asemenea, afiseaza diverse mesaje in functie de starea sistemului, ghidand utilizatorul pe parcursul procesului.

Workflow:
Initializare: functia setup initiaza toate componentele si configureaza intreruperile
Procesul de reset:
-declansat de butonul de reset
-seteaza suma totala la zero
-misca servomotorul in pozitia maxima, asteapta, apoi revine la pozitia initiala
-buzzerul semnalizeaza finalizarea procesului de reset
Scanarea bancnotelor:
-declansat de butonul pentru introducerea bancnotelor
-bancnota este scanata de senzorul de culoare
-valorile RGB sunt mediate si procesate pentru a determina valoarea bancnotei
-servomotorul se misca pentru a depozita bancnota, apoi revine la pozitia initiala
-buzzerul semnalizeaza finalizarea procesului de depozitare
Actualizarea LCD-ului:
-suma totala este actualizata pe LCD
-mesajele sunt afisate pentru a ghida utilizatorul
